﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;

namespace ModbusDemo.windows
{   
    class TransferPool
    { 
        public string position;//位置
        public class Source: ModbusAttribute //水源
        {
            public string Southeastwater; //东南水
            public string Northeastwater; //东北水
            public string Southwestwater; //西南水
            public string Northwestwater; //西北水
            public string Timingtime;    //定时时间
            public bool   system_Statue;
        }
        public class passageway //通道
        {
            public Agitator agitator;
            public pump pump;
            public Level Level;//液位属性
        }
        public class Agitator: ModbusAttribute //搅拌器
        {
            public bool state;
            public ushort[] current;//电流
            public ushort[] Voltage;//电压
        }
        public class pump: ModbusAttribute//泵
        {
            public bool state;
            public ushort[] current;//电流
            public ushort[] Voltage;//电压
        }

        public class Level: ModbusAttribute //液位属性
        {
            public ushort[] level;//液位
            public ushort[] passageway;       //液位通道
            public double[] Lowwaterlevel;   // 液位最低水位
            public double[] Peaklevel;       // 液位最高水位
        }
        public class ModbusAttribute //modbus属性
        {
            public byte[]   SlaveAddress;
            public ushort[] RegisterAddress;
        }
    }
}
